﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Czolg
{
    struct Punkt
    {
        private int x;
        private int y;

        public Punkt(int x, int y)
        {
            this.x = x;
            this.y = y;
        }

        public int PobierzX()
        {
            return x;
        }
        public int PobierzY()
        {
            return y;
        }
        #region Zadanie 2
        public void ZmienX(int noweX)
        {
            x = noweX;
        }
        public void ZmienY(int noweY)
        {
            y = noweY;
        }
        #endregion

    }

    class Dzialo
    {
        private double kaliber;
        public Dzialo(double kaliber)
        {
            this.kaliber = kaliber;
        }

        public double PobierzKaliber()
        {
            return kaliber;
        }
        #region Zadanie 2
        public void ZmienKaliber(double nowyKaliber)
        {
            kaliber = nowyKaliber;
        }

        public Dzialo(Dzialo prototyp)
        {
            kaliber = prototyp.kaliber;
        }
        #endregion

    }

    class Czolg
    {
        private int numerCzolgu;
        private string nazwa;
        private Dzialo dzialo;
        private Punkt pozycja;

        public Czolg(int nrCzolgu, string nazwa, double kaliber, int pozycjaX, int pozycjaY)
        {
            numerCzolgu = nrCzolgu;
            this.nazwa = nazwa;
            dzialo = new Dzialo(kaliber);
            pozycja = new Punkt(pozycjaX, pozycjaY);
        }

        public Czolg(int nrCzolgu, string nazwa, Dzialo dzialo,Punkt punkt)
            : this(nrCzolgu, nazwa, dzialo.PobierzKaliber(), punkt.PobierzX(), punkt.PobierzY())
        {
        }

        public Czolg(int nrCzolgu, string nazwa, double kaliber)
            : this(nrCzolgu, nazwa, kaliber, 0, 0)
        {
        }

        public Czolg(int nrCzolgu, string nazwa)
            : this(nrCzolgu, nazwa, 76.2)
        {
        }
        public Czolg(int nrCzolgu)
            : this(nrCzolgu, "Rudy")
        {
        }

        public string PobierzInformacje()
        {
            return string.Format("Czołg nr {0} o nazwie {1}, klaiber działa {2} znajdyuje się w punkcie ({3}; {4})",
                numerCzolgu, nazwa, dzialo.PobierzKaliber(), pozycja.PobierzX(), pozycja.PobierzY());
        }

        #region Zadanie 2
        public void ZmienKaliber(double nowyKaliber)
        {
            dzialo.ZmienKaliber(nowyKaliber);
        }
        public void ZmienPozycje(int x,int y)
        {
            pozycja.ZmienX(x);
            pozycja.ZmienY(y);
        }
        public void ZmienNazwe(string nowaNazwa)
        {
            nazwa = nowaNazwa;
        }
        public Czolg Klonuj()
        {
            return (Czolg)this.MemberwiseClone();
        }
        public Czolg(Czolg prototyp)
        {
            numerCzolgu = prototyp.numerCzolgu;
            nazwa = prototyp.nazwa;
            dzialo = new Dzialo(prototyp.dzialo);
            pozycja = prototyp.pozycja;
        }
        #endregion

    }
}
