﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LiczbyZespolone
{
    public struct Zespolona
    {
        public double Re { set; get; }      
        public double Im { set; get; }    

        public Zespolona(double re, double im) : this()
        {
            Re = re;
            Im = im;
        }
        public Zespolona(double re)
            : this(re, 0)
        {
        }

        //definicja domyślnego konstruktora jest niedozwolona
        //public Zepolona()

        public static Zespolona operator +(Zespolona x)
        {
            return x;
        }
        public static Zespolona operator -(Zespolona x)
        {
            return new Zespolona(-x.Re, -x.Im);
        }
        //operator ~ będzie wyznaczał liczbę sprzężoną
        public static Zespolona operator ~(Zespolona x)
        {
            return new Zespolona(x.Re, -x.Im);
        }
        //operator ! będzie wyznaczał moduł liczby zespolone
        public static double operator !(Zespolona x)
        {            
            return Math.Sqrt(x.Re * x.Re + x.Im * x.Im);
        }

        public static Zespolona operator +(Zespolona x,  Zespolona y)
        {
            return new Zespolona(x.Re + y.Re, x.Im + y.Im);
        }

        public static Zespolona operator -(Zespolona x, Zespolona y)
        {
            return new Zespolona(x.Re - y.Re, x.Im - y.Im);
        }

        public static Zespolona operator *(Zespolona x, Zespolona y)
        {
            return new Zespolona(x.Re * y.Re, x.Im * y.Im);
        }

        public static Zespolona operator /(Zespolona x, Zespolona y)
        {
            Zespolona z = new Zespolona();
            z.Re = (x.Re * y.Re + x.Im * y.Im) / (y.Re * y.Re + y.Im*y.Im);
            z.Im = (x.Im * y.Re - x.Re * y.Im) / (y.Re * y.Re + y.Im * y.Im);
            return z;
        }

        public static bool operator ==(Zespolona x, Zespolona y)
        {
            return x.Re == y.Re && x.Im == y.Im;
        }

        public static bool operator !=(Zespolona x, Zespolona y)
        {
            return ! (x == y);
        }

        public override bool Equals(object obj)
        {
            if (obj == null || !(obj is Zespolona))
                return false;
            Zespolona y = (Zespolona) obj;
            return this.Re == y.Re && this.Im == y.Im;
        }
        public override int GetHashCode()
        {
            return (int) !this;
        }

        public static explicit operator double(Zespolona x)
        {
            return x.Re;
        }

        public static implicit operator Zespolona(double d)
        {
            return new Zespolona(d);
        } 
    }
}
