﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ObiektyAstronomiczne
{
    public class Gwiazda : CialoNiebieskie
    {
        public enum KlasyGwiazd { O, B, A, F, G, K, M, R, N, S };
        protected KlasyGwiazd KlasaGwiazdy { set; get; }

        private byte podklasaGwiazdy;
        protected byte PodklasaGwiazdy
        {
            set
            {
                if (value < 1 || value > 9)
                    throw new ZlaPodklasaGwiazdyException();
                podklasaGwiazdy = value;
            }
            get { return podklasaGwiazdy; }
        }

        public const double MASASLONCA = 1.9889e30;
        public int IloscMasSlonca
        {
            get { return (int)(masa /  MASASLONCA);}
        }
        public Gwiazda(string nazwa,double masa,string opis,KlasyGwiazd  klasa, byte podklasa):
            base(nazwa,masa,opis)
        {
            KlasaGwiazdy = klasa;
            if (podklasa < 1 || podklasa > 9)
                throw new ZlaPodklasaGwiazdyException();
            PodklasaGwiazdy = podklasa;
        }

        public new string ZwrocInformacje()
        {
            return string.Format("Gwiazda {0} jest klasy {2}{3} i ma masę {1}", 
                nazwa, masa,KlasaGwiazdy, PodklasaGwiazdy);
        }

        public class ZlaPodklasaGwiazdyException : ArgumentException
        {
            public ZlaPodklasaGwiazdyException()
                : base("Każda klasa ma tylko 9 podklas.")
            {
            }
        }
     }
}
