﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Przyklad1
{
    class Autor
    {
        private string imie;
        private string nazwisko;
        public Autor(string imie, string nazwisko)
        {
            if (string.IsNullOrEmpty(imie) || string.IsNullOrEmpty(nazwisko))
            {
                throw new ArgumentException("Imie i nazwisko nie może być puste");
            }
            this.imie = imie;
            this.nazwisko = nazwisko;
        }
        public string Imie { get { return imie; } }
        public string Nazwisko { get { return nazwisko; } }
    }
    class Ksiazka
    {
        public Autor Autor { set; get; }
        public string Tytul { set; get; }

        public int RokWydania { set; get; }
        public string Wydawnictwo { set; get; }

        public string Isbn { set; get; }

        public override string ToString()
        {
            return string.Format("{0} {1}., \"{2}\", {3}, {4}, {5}",
                Autor.Nazwisko, Autor.Imie[0], Tytul, Wydawnictwo, RokWydania, Isbn);
        }

        public override bool Equals(object obj)
        {
            if( obj == null) return false;
			if( this.GetType() != obj.GetType() ) return false;
			Ksiazka k = (Ksiazka) obj;

            if (Isbn != null || k.Isbn != null)
            {
                if (Isbn == k.Isbn)
                    return true;
                else
                    return false;
            }
			if( !string.Equals(Tytul, k.Tytul) ) return false;
			if( !Autor.Equals(Autor, k.Autor) ) return false;
            if (RokWydania != k.RokWydania) return false;
            if (Wydawnictwo != k.Wydawnictwo) return false;
			return true;		
        }

        public override int GetHashCode()
        {
            if (Isbn != null)
                return Isbn.GetHashCode();
            return ToString().GetHashCode();
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Autor autor = new Autor("Stephen", "Perry");
            Ksiazka k1 = new Ksiazka()
            {
                Autor = autor,  //new Autor("Stephen", "Perry");
                Tytul = "C# i .NET",
                Wydawnictwo = "Helion",
                RokWydania = 2006,  //2007,
                //Isbn = "83-246-0320-4"

            };
            Ksiazka k2 = new Ksiazka()
            {
                Autor = autor,
                Tytul = "C# i .NET",
                Wydawnictwo = "Helion",
                RokWydania = 2006,
                //Isbn = "83-246-0320-4"
            };
            if (k1 == k2)
                Console.WriteLine("Dwa te same obiekty");
            else
                Console.WriteLine("Dwa różne obiekty");
            if (k1.Equals(k2))
                Console.WriteLine("Dwie te same ksiązki");
            else
                Console.WriteLine("Dwie rózne ksiązki");
            Console.WriteLine("Informacje o książce: {0}", k1);
            Console.WriteLine("Wartość skrótu: {0} i {1}", k1.GetHashCode(), k2.GetHashCode());

            Console.ReadKey();
        }
    }
}
