﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Produkty;
using Fabryki;

namespace DodatkoweProdukty
{
    public class SniadanieDieta : SniadanieBase
    {
        public SniadanieDieta(decimal cena)
            : base(cena)
        {
        }

        public override string OpisSniadania()
        {
            return string.Format("Mało nie znaczy tanio, cena {0}", cena);
        }
    }

    public class ObiadDieta : ObiadBase
    {
        public ObiadDieta(double waga)
            : base(waga)
        {
        }
        public override string OpisObiadu()
        {
            return string.Format("Zaproś przyjaciela, obiad waży {0}", waga);
        }
    }

    public class KolacjaDieta : KolacjaBase
    {
        public KolacjaDieta(double iloscKalorii)
            : base(iloscKalorii)
        {
        }

        public override string OpisKolacji
        {
            get { return string.Format("Kolacje oddaj wrogowi, ilość kalorii {0}", iloscKalorii); }
        }
    }

    public class KuchniaDiete : IKuchnia
    {
        #region IKuchnia Members
        public SniadanieBase PrzygotujSniadanie()
        {
            return new SniadanieDieta(150);
        }

        public ObiadBase PrzygotujObiad()
        {
            return new ObiadDieta(30);
        }

        public KolacjaBase PrzygotujKolacje()
        {
            return new KolacjaDieta(12.4);
        }

        #endregion
    }
}
