﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Produkty;

namespace Fabryki
{
    public interface IKuchnia
    {
        SniadanieBase PrzygotujSniadanie();
        ObiadBase PrzygotujObiad();
        KolacjaBase PrzygotujKolacje();
    }

    public class KuchniaWloska : IKuchnia
    {
        #region IKuchnia Members
        public SniadanieBase PrzygotujSniadanie()
        {
            return new SniadanieWloskie(15);
        }

        public ObiadBase PrzygotujObiad()
        {
            return new ObiadWloski(300);
        }

        public KolacjaBase PrzygotujKolacje()
        {
            return new KolacjaWloska(1200);
        }

        #endregion
    }
}
