﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Produkty;
using Fabryki;

using DodatkoweProdukty;


namespace Klient
{
    static class Menu
    {
        public static IKuchnia Utworz(int i)
        {
            IKuchnia kuchnia = null;
            switch (i)
            {
                case 1: kuchnia = new KuchniaWloska();
                    break;
                case 2: kuchnia = new KuchniaDiete();
                    break;
            }
            return kuchnia;
        }

        public static int Wyswietl()
        {
            Console.Clear();
            Console.WriteLine("\n\n\n\n");
            Console.WriteLine("\t\t1 - Kuchnia włoska\n");
            Console.WriteLine("\t\t2 - Kuchnia dla osób pragnących schudnąć\n");
            Console.WriteLine("\t\t0 - Koniec");
            int i;
            bool b;
            do
            {
                do
                {
                    b = int.TryParse(Console.ReadLine(), out i);
                }
                while (!b);
            }
            while (0 > i || i > 2);
            return i;
        }
    }

    class Klient
    {
        private SniadanieBase sniadanie;
        private ObiadBase obiad;
        private KolacjaBase kolacja;
        private IKuchnia kuchnia;

        public int WyswietlMenu()
        {
            Console.WriteLine("1 - Propozycja śniadania");
            Console.WriteLine("2 - Propozycja obiadu");
            Console.WriteLine("3 - Propozycja kolacji");
            Console.WriteLine("4 - Powrót do menu główne");
            int i;
            bool b;
            do
            {
                b = int.TryParse(Console.ReadLine(), out i);
            }
            while (!b);
            return i;
        }
        public void Uruchom()
        {
            int i, j;
            while (true)
            {
                i = Menu.Wyswietl();
                if (i == 0)
                    break;
                kuchnia = Menu.Utworz(i);
                sniadanie = kuchnia.PrzygotujSniadanie();
                obiad = kuchnia.PrzygotujObiad();
                kolacja = kuchnia.PrzygotujKolacje();
                do
                {
                    j = WyswietlMenu();
                    Console.Clear();
                    switch (j)
                    {
                        case 1: Console.WriteLine(sniadanie.OpisSniadania());
                            Console.ReadKey();
                            break;
                        case 2: Console.WriteLine(obiad.OpisObiadu());
                            Console.ReadKey();
                            break;
                        case 3: Console.WriteLine(kolacja.OpisKolacji);
                            Console.ReadKey();
                            break;
                    }
                }
                while (j != 4);
            }
        }

    }

    class Program
    {
        static void Main(string[] args)
        {
            Klient k = new Klient();
            k.Uruchom();
        }
    }
}
