﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Produkty
{
    public abstract  class SniadanieBase
    {
        protected decimal cena;

        public SniadanieBase(decimal cena)
        {
            this.cena = cena;
        }
        public abstract string OpisSniadania();
    }

    public abstract class ObiadBase
    {
        protected double waga;
        public ObiadBase(double waga)
        {
            this.waga = waga;
        }
        public abstract string OpisObiadu();
    }

    public abstract class KolacjaBase
    {
        protected double iloscKalorii;
        public KolacjaBase(double iloscKalorii)
        {
            this.iloscKalorii = iloscKalorii;
        }
        public abstract string OpisKolacji
        {
            get;
        }
    }

    public class SniadanieWloskie : SniadanieBase
    {
        public SniadanieWloskie(decimal cena)
            : base(cena)
        {
        }

        public override string OpisSniadania()
        {
            return string.Format("To jest włoskie śniadanie w cenie {0}", cena);
        }
    }

    public class ObiadWloski : ObiadBase
    {
        public ObiadWloski(double waga)
            : base(waga)
        {
        }
        public override string OpisObiadu()
        {
            return string.Format("To jest obiad włoski o wadze {0}", waga);
        }
    }

    public class KolacjaWloska : KolacjaBase
    {
        public KolacjaWloska(double iloscKalorii)
            : base(iloscKalorii)
        {
        }

        public override string OpisKolacji
        {
            get { return string.Format("To jest włoska kolacja która zawiera {0} kalorii", iloscKalorii); }
        }
    }
}
