﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using Osoby;
using DoHtmla;
using Samochody;

namespace Test
{
    class Program
    {
        static void UtworzDokumentHtml(object[] tab)
        {
            StreamWriter sw = null;
            try
            {
                sw = new StreamWriter("test.html");
                sw.WriteLine("<html><head></head><body><ul>");
                foreach (object o in tab)
                {
                    sw.Write("<li>");
                    IHtml iHtml = o as IHtml;
                    if (iHtml != null)
                    {
                        sw.Write(iHtml.DoHtmla());
                    }
                    else
                    {
                        sw.Write(o.ToString());
                    }
                    sw.WriteLine("</li>");
                }
                sw.Write("</ul></body></html>");
            }
            finally
            {
                if (sw != null)
                    sw.Close();
            }
        }

        static void Main(string[] args)
        {
            Osoba osoba = new Osoba() { Imie = "Jan", Nazwisko = "Kowalski", RokUrodzenia = 1990 };
            Student student = new Student() { Imie = "Paweł", Nazwisko = "Nowak", RokUrodzenia = 1988, NumerIndeksu = "1234" };
            Samochod samochod = new Samochod() { Producent = "Opel", Marka = "Astra" };

            object[] obj = { osoba, student, samochod };
            UtworzDokumentHtml(obj);

            Console.WriteLine("Dokument html został utworzony.");
            Console.ReadKey();
        }
    }
}
