﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MojaLista
{
    public class ListaJednokierunkowa2<T> : IEnumerable<T>
    {
        private class Wezel
        {
            public T dane;
            public Wezel nastepny;
            public Wezel(T x, Wezel nastepny)
            {
                this.nastepny = nastepny;
                dane = x;
            }
        }

        Wezel glowa = null;

        public void DodajDoGlowy(T x)
        {
            glowa = new Wezel(x, glowa);
        }

        #region IEnumerable<T> Members

        public IEnumerator<T> GetEnumerator()
        {
            Wezel tmp = glowa;
            while (tmp != null)
            {
                yield return tmp.dane;
                tmp = tmp.nastepny;
            }
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        #endregion

        public IEnumerable<T> CoDrugi
        {
            get
            {
                return new CoDrugiElement(this);
            }
        }

        private class CoDrugiElement : IEnumerable<T>
        {
            #region IEnumerable<T> Members
            private ListaJednokierunkowa2<T> lista;
            public CoDrugiElement(ListaJednokierunkowa2<T> lista)
            {
                this.lista = lista;
            }
            public IEnumerator<T> GetEnumerator()
            {
                Wezel tmp = lista.glowa;
                while (tmp != null)
                {
                    tmp = tmp.nastepny;
                    if (tmp != null)
                    {
                        yield return tmp.dane;
                        tmp = tmp.nastepny;
                    }
                }
            }

            #endregion

            #region IEnumerable Members

            System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
            {
               return GetEnumerator();
            }

            #endregion
        }

    }
}
