﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Osoby
{
    class Osoba : IFormattable
    {
        public string Imie { set; get; }
        public string Nazwisko { set; get; }
        public int RokUrodzenia { set; get; }

        #region IFormattable Members

        public virtual string ToString(string format, IFormatProvider formatProvider)
        {
            if (string.IsNullOrEmpty(format))
            {
                return string.Format("{0} {1}", Imie, Nazwisko);
            }
            if (format == "p" || format == "P")
            {
                return string.Format("{0} {1} ur. {2}r.", Imie, Nazwisko, RokUrodzenia);
            }
            throw new FormatException("Niepoprawne formatownie: " + format);
        }

        #endregion
    }

    class Program
    {
        static void Main(string[] args)
        {
            Osoba o = new Osoba { Imie = "Jan", Nazwisko = "Kowalski", RokUrodzenia = 1989 };

            Console.WriteLine("Pan {0}", o);
            Console.WriteLine("Pan {0:p}", o);

            string s1 = string.Format("Pan {0}", o);
            string s2 = string.Format("Pan {0:P}", o);
            Console.WriteLine(s1);
            Console.WriteLine(s2);

            string s3 = string.Format("Pan {0:f}", o);

            Console.ReadKey();
        }
    }
}
