using System;
using System.Collections.Generic;
using System.Text;


namespace KolejkaFIFO
{
    public class Kolejka
    {
        private string[] elementy;
        private int pierwszy;
        private int ostatni;

        public void Utworz(int liczbaElementow)
        {
            pierwszy = ostatni = -1;
            elementy = new string[liczbaElementow];
        }

        public bool CzyPelna()
        {
            return ((pierwszy == 0 && ostatni == elementy.Length - 1) || pierwszy == ostatni + 1);               
        }

        public void DodajDoKolejki(string os)
        {
            if (CzyPelna())
                throw new InvalidOperationException("Kolejka jest pena");
            if (ostatni == elementy.Length - 1 || ostatni == -1)
            {
                elementy[0] = os;
                ostatni = 0;
                if (pierwszy == -1)
                    pierwszy = 0;
            }
            else
                elementy[++ostatni] = os;
        }

        public bool CzyPusta()
        {
            return pierwszy == -1;
        }

        public string UsunZKolejki()
        {
            if (CzyPusta())
                throw new InvalidOperationException("Kolejka jest pusta");
            string tmp;
            tmp = elementy[pierwszy];
            if (pierwszy == ostatni)
                ostatni = pierwszy = -1;
            else
                if (pierwszy == elementy.Length - 1)
                    pierwszy = 0;
                else
                    pierwszy++;
            return tmp;
        }

        public void Wyczysc()
        {
            Utworz(elementy.Length);
        }

        public string SprawdzElement()
        {
            if (CzyPusta())
                throw new InvalidOperationException("Kolejka jest pusta");
            return elementy[pierwszy];
        }

        public int PobierzLiczbeElementow()
        {
            if(pierwszy == -1)
                return 0;
            if (pierwszy <= ostatni)
                return ostatni - pierwszy + 1;
            return elementy.Length - pierwszy + ostatni + 1;
        }
    }
}
