﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;

namespace RozszerzeniaKonsoli
{
    public class RozszerzonaKonsola: IDisposable
    {    
        private StreamWriter sw;
        protected bool disposed = false;

        public RozszerzonaKonsola(string scizka)
        {
            sw = new StreamWriter(scizka);
        }

        public void WriteLine(string s)
        {
            Console.WriteLine(s);
            sw.WriteLine(s);
        }
        public void WriteLine(string s, params object[] args)
        {
            Console.WriteLine(s, args);
            sw.WriteLine(s, args);
        }

        public void Write(string s)
        {
            Console.Write(s);
            sw.Write(s);            
        }
        public void Write(string s, params object[] args)
        {
            Console.Write(s, args);
            sw.Write(s, args);
        }

        public string ReadLine()
        {
            string s = Console.ReadLine();
            sw.WriteLine("###{0}###",s);
            return s;
        }
        public int Read()
        {
            int n = Console.Read();
            sw.WriteLine("$$${0}$$$", n);
            return n;
        }
        protected virtual void Dispose(bool disposing)
        {
            if (disposed)
                return;
            if (disposing)
            {
                sw.Dispose();
            }
            disposed = true;

        }
        public void Dispose()
        {			
            Dispose(true);
            GC.SuppressFinalize(this);
        }
        ~RozszerzonaKonsola()
        {
            Dispose(false);
        }

        public bool IsDisposed
        {
            get { return disposed; }
        }

    }
}
