﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Samochody
{
    public class Samochod : IComparable<Samochod>
    {
        public string Marka { set; get; }
        public string Model { set; get; }

        public int RokProdukcji { set;  get; }
        public decimal Cena { set; get; }

        public override string ToString()
        {
            return string.Format("Samochód {0,-10} {1,-10} cena: {2,-10} rok produkcji {3,-10}",
                Marka, Model, Cena, RokProdukcji);
        }

        #region IComparable<Samochod> Members

        public int CompareTo(Samochod other)
        {
            return Marka.CompareTo(other.Marka);
        }

        #endregion

        
        public class PoModelu : IComparer<Samochod>
        {
            #region IComparer<Samochod> Members

            public int Compare(Samochod x, Samochod y)
            {
                return string.Compare(x.Model, y.Model, true);
            }

            #endregion
        }
        

        public class PoCenie : IComparer<Samochod>
        {
            #region IComparer<Samochod> Members

            public int Compare(Samochod x, Samochod y)
            {
                return x.Cena.CompareTo(y.Cena);
            }

            #endregion
        }

        public class PoRokuProdukcji : IComparer<Samochod>
        {
            #region IComparer<Samochod> Members

            public int Compare(Samochod x, Samochod y)
            {
                return x.RokProdukcji.CompareTo(y.RokProdukcji);
            }

            #endregion
        }
    }
}
