﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Reflection;
using System.IO;

using InformacjeOZestawie;

namespace eksploratorTypow
{
    class Program
    {
        static void Main(string[] args)
        {
            if(args.Length < 2)
            {
                Console.WriteLine("Program nalezy wywołać:");
                Console.WriteLine("EksploratorTypow <nazwa zestawu do badania> <nazwa pliku z raportem>");
                Console.ReadKey();
                return;
            }

            if(!File.Exists(args[0]))
            {
                Console.WriteLine("Podany zestaw do badania nie istnieje!!!");
                Console.ReadKey();
                return;
            }
            StreamWriter sw = null;
            try
            {
                Assembly asembly = Assembly.LoadFrom(args[0]);
                sw = new StreamWriter(args[1]);
                Zestaw.SporzadzRaport(asembly, sw);
                Console.WriteLine("Raport został sporządzony!!!");
            }
            catch (IOException ex)
            {
                Console.WriteLine("Uwaga wyjątek!!!\n{0}", ex.Message);
            }
            finally
            {
                if (sw != null)
                    sw.Close();
            }
            Console.ReadKey();
        }
    }
}
