﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using KomisBiblioteka;

using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Serialization;

namespace Komis
{
    class Program
    {
        static List<Samochod> samochody ;
        static List<Osoba> wlasciciele ;

        static void Menu()
        {
            Console.WriteLine("\n\n\n\n\n");
            Console.WriteLine("\t\tA - Dodaj samochód\n");
            Console.WriteLine("\t\tB - Wypisz wszystkie samochody\n");
            Console.WriteLine("\t\tS - Zapisz do pliku\n");
            Console.WriteLine("\t\tX - Zapis do pliku XML\n");

            Console.WriteLine("\t\tK - Koniec\n");
        }

        static void DodajSamochod()
        {
            string marka, producent, imie, nazwisko, telefon;
            int rok;
            decimal cenaZakupu, cenaSprzedazy;
            Console.Write("Podaj markę samochodu: ");
            marka = Console.ReadLine();
            Console.Write("Podaj producenta samochodu: ");
            producent = Console.ReadLine();
            Console.Write("Podaj cenę zakupu: ");
            cenaZakupu = decimal.Parse( Console.ReadLine());
            Console.Write("Podaj ceną sprzedaży: ");
            cenaSprzedazy = decimal.Parse(Console.ReadLine());
            Console.Write("Podaj rok produkcji: ");
            rok = int.Parse( Console.ReadLine());
            Console.Write("Podaj imię właściciela: ");
            imie = Console.ReadLine();
            Console.Write("Podaj nazwisko właściciela: ");
            nazwisko = Console.ReadLine();
            Console.Write("Podaj telefon właściciela: ");
            telefon  = Console.ReadLine();
            Osoba o = new Osoba() { Imie = imie, Nazwisko = nazwisko, NumerTelefonu = telefon };
            wlasciciele.Add(o);
            Samochod s = new Samochod()
            {
                CenaSprzedazy = cenaSprzedazy,
                CenaZakupu = cenaZakupu,
                Marka = marka,
                PoprzedniWlasciciel = o,
                Producent = producent,
                RokProdukcji = rok
            };
            samochody.Add(s);
        }

        private static void WyswietlSamochody()
        {
            int i = 1;
            foreach (Samochod s in samochody)
            {
                Console.WriteLine("{0}\t{1}, {2}, {3}, {4:C}, {5:C}",
                    i, s.Producent, s.Marka, s.RokProdukcji, s.CenaZakupu, s.CenaSprzedazy);
                Console.WriteLine("\t{0} {1}, {2}", s.PoprzedniWlasciciel.Imie,
                    s.PoprzedniWlasciciel.Nazwisko, s.PoprzedniWlasciciel.NumerTelefonu);
                if (i % 12 == 0)
                    Console.ReadKey(true);
                i++;                    
            }
            Console.ReadKey(true);
        }

        static void Main(string[] args)
        {
            Wczytaj();
            char c;
            do
            {
                Menu();
                c = Console.ReadKey(true).KeyChar;
                switch (c)
                {
                    case 'a':
                    case 'A': DodajSamochod();
                        break;
                    case 'b':
                    case 'B': WyswietlSamochody();
                        break;
                    case 's':
                    case 'S': Zapisz();
                        break;
                    case 'x':
                    case 'X': ZapiszDoXml();
                        break;
                }
            }
            while (!(c == 'k' || c == 'K'));
        }

        private static void Wczytaj()
        {
            if (!File.Exists("Osoby.dat") || !File.Exists("Samochody.dat"))
            {
                wlasciciele = new List<Osoba>();
                samochody = new List<Samochod>();
                Samochod.PoprzedniWlasciciele = wlasciciele;
                return;
            }
            FileStream fs = null;
            BinaryFormatter formater = new BinaryFormatter();
            try
            {
                fs = new FileStream("Osoby.dat", FileMode.Open);
                wlasciciele = (List<Osoba>)formater.Deserialize(fs);
                Samochod.PoprzedniWlasciciele = wlasciciele;
                fs.Close();
                fs = new FileStream("Samochody.dat", FileMode.Open);
                samochody = (List<Samochod>)formater.Deserialize(fs);
            }
            finally
            {
                if (fs != null)
                    fs.Close();
            }
        }

        private static void Zapisz()
        {
            FileStream fs = null;
            BinaryFormatter formater = new BinaryFormatter();
            try
            {
                fs = new FileStream("Osoby.dat", FileMode.Create);
                formater.Serialize(fs, wlasciciele);
                fs.Close();
                fs = new FileStream("Samochody.dat", FileMode.Create);
                formater.Serialize(fs, samochody);
            }
            finally
            {
                if (fs != null)
                    fs.Close();
            }
        }

        private static void ZapiszDoXml()
        {
            XmlSerializer serializer = new XmlSerializer(typeof(List<Samochod>));
            using( FileStream fs = new FileStream("Oferta.xml", FileMode.Create))
            {
                serializer.Serialize(fs, samochody);
            }            
        }
    }
}
