﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace KomisBiblioteka
{
    [Serializable]
    public class Samochod: ISerializable
    {
        public string Marka { set; get; }
        public string Producent { set; get; }
        [XmlAttribute]
        public int RokProdukcji { set; get; }
        [XmlIgnore]
        public decimal CenaZakupu { set; get; }
        [XmlElement("Cena")]
        public decimal CenaSprzedazy { set; get; }
        [XmlIgnore]
        public Osoba PoprzedniWlasciciel { set; get; }

        #region ISerializable Members

        public static List<Osoba> PoprzedniWlasciciele ;
        public void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            info.AddValue("Marka", Marka);
            info.AddValue("Producent", Producent);
            info.AddValue("RokProdukcji", RokProdukcji);
            info.AddValue("CenaZakupu", CenaZakupu);
            info.AddValue("CenaSprzedazy", CenaSprzedazy);
            info.AddValue("Id",PoprzedniWlasciciel.IdOsoby);
        }
        protected Samochod(SerializationInfo info, StreamingContext context)
        {
            Marka = info.GetString("Marka");
            Producent = info.GetString("Producent");
            RokProdukcji = info.GetInt32("RokProdukcji");
            CenaZakupu = info.GetDecimal("CenaZakupu");
            CenaSprzedazy = info.GetDecimal("CenaSprzedazy");
            int id = info.GetInt32("Id");

            foreach (Osoba o in PoprzedniWlasciciele)
            {
                if (o.IdOsoby == id)
                {
                    PoprzedniWlasciciel = o;
                    break;
                }
            }
            if (PoprzedniWlasciciel == null)
                throw new Exception("Nie ma właściciela o podanym id");
        }

        #endregion

        public Samochod()
        {
        }
    }
}
